SystemOrganization addCategory: #'PharoBot-Core-Tests'!

TestCase subclass: #BatteryTest
	instanceVariableNames: 'battery'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-Core-Tests'!

!BatteryTest class methodsFor: 'accessing' stamp: 'NahuelGarbezza 12/22/2012 18:41'!
packageNamesUnderTest

	^#('PharoBot-Core')! !

!BatteryTest methodsFor: 'percentage' stamp: 'NahuelGarbezza 12/9/2012 18:10'!
testChargePercentageLessThan100

	battery := Battery new.
	
	battery consume: 500.
	self assert: 50 equals: battery chargePercentage.
	battery consume: 200.
	self assert: 30 equals: battery chargePercentage.! !

!BatteryTest methodsFor: 'percentage' stamp: 'NahuelGarbezza 12/9/2012 18:11'!
testChargePercentageOf0

	battery := Battery new.
	
	battery consume: battery capacity.
	self assert: 0 equals: battery chargePercentage.! !

!BatteryTest methodsFor: 'percentage' stamp: 'NahuelGarbezza 12/9/2012 18:11'!
testChargePercentageOf100

	battery := Battery new.
	self assert: 100 equals: battery chargePercentage.! !

TestCase subclass: #RobotTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-Core-Tests'!

!RobotTest class methodsFor: 'accessing' stamp: 'NahuelGarbezza 12/22/2012 18:40'!
packageNamesUnderTest

	^#('PharoBot-Core')! !

!RobotTest methodsFor: 'state' stamp: 'NahuelGarbezza 12/22/2012 18:36'!
testBrushDownIfItIsAlreadyBrushDownDoesNothing

	|robot|
	"given"
	robot := Robot new.
	"when"
	robot brushDown.

	self shouldnt: [robot brushDown] raise: Error.! !

!RobotTest methodsFor: 'state' stamp: 'NahuelGarbezza 12/22/2012 18:36'!
testBrushUpIfItIsAlreadyBrushUpDoesNothing

	|robot|
	"given"
	robot := Robot new.
	"when"
	robot brushUp.

	self shouldnt: [robot brushUp] raise: Error.! !

!RobotTest methodsFor: 'directioning' stamp: 'NahuelGarbezza 12/22/2012 19:02'!
testDefaultDirectionIsNorth

	|robot|
	"when"
	robot := Robot new.
	self assert: robot direction equals: 90! !

!RobotTest methodsFor: 'positioning' stamp: 'NahuelGarbezza 12/22/2012 17:16'!
testDefaultPositionIsZeroZero

	|robot|
	"when"
	robot := Robot new.
	"then"
	self assert: robot position equals: 0@0! !

!RobotTest methodsFor: 'state' stamp: 'NahuelGarbezza 12/22/2012 16:16'!
testDefaultStateIsBrushUp

	|robot|
	"when"
	robot := Robot new.
	"then"
	self assert: robot isBrushUp.! !

!RobotTest methodsFor: 'directioning' stamp: 'NahuelGarbezza 12/22/2012 18:18'!
testDirectioningToEast

	|robot|
	"given"
	robot := Robot new.
	"when"
	robot east.
	"then"
	self assert: robot direction equals: 0! !

!RobotTest methodsFor: 'directioning' stamp: 'NahuelGarbezza 12/22/2012 18:19'!
testDirectioningToNorth

	|robot|
	"given"
	robot := Robot new.
	"when"
	robot north.
	"then"
	self assert: robot direction equals: 90! !

!RobotTest methodsFor: 'directioning' stamp: 'NahuelGarbezza 12/22/2012 18:19'!
testDirectioningToSouth

	|robot|
	"given"
	robot := Robot new.
	"when"
	robot south.
	"then"
	self assert: robot direction equals: 270! !

!RobotTest methodsFor: 'directioning' stamp: 'NahuelGarbezza 12/22/2012 18:18'!
testDirectioningToWest

	|robot|
	"given"
	robot := Robot new.
	"when"
	robot west.
	"then"
	self assert: robot direction equals: 180! !

!RobotTest methodsFor: 'movements - brush down' stamp: 'NahuelGarbezza 12/22/2012 18:56'!
testLiftingTheBrushFinishesTheCurrentPath

	|robot|
	"given"
	robot := Robot new.
	robot brushDown.
	robot move: 40; north; move: 120.
	"when"
	robot brushUp.
	robot brushDown.
	"then"
	self assert: robot numberOfPaths equals: 2.
	self assert: robot paths first numberOfPoints equals: 3.
	self assert: robot paths second numberOfPoints equals: 1.! !

!RobotTest methodsFor: 'movements' stamp: 'NahuelGarbezza 12/22/2012 18:27'!
testMoveANegativeAmountInXAxis

	|robot|
	"given"
	robot := Robot new.
	robot east.
	"when"
	robot move: -70.
	"then"
	self assert: robot position equals: -70 @ 0! !

!RobotTest methodsFor: 'movements' stamp: 'NahuelGarbezza 12/22/2012 18:28'!
testMoveANegativeAmountInYAxis

	|robot|
	"given"
	robot := Robot new.
	robot south.
	"when"
	robot move: -20.
	"then"
	self assert: robot position equals: 0 @ 20! !

!RobotTest methodsFor: 'movements' stamp: 'NahuelGarbezza 12/22/2012 18:33'!
testMoveInDiagonal

	|robot|
	"given"
	robot := Robot new.
	robot direction: 45.
	"when"
	robot move: 8 sqrt.
	"then"
	self assert: robot position equals: 2 @ 2! !

!RobotTest methodsFor: 'movements' stamp: 'NahuelGarbezza 12/22/2012 18:26'!
testMoveStraightToEast

	|robot|
	"given"
	robot := Robot new.
	robot east.
	"when"
	robot move: 250.
	"then"
	self assert: robot position equals: 250 @ 0! !

!RobotTest methodsFor: 'movements' stamp: 'NahuelGarbezza 12/22/2012 18:26'!
testMoveStraightToNorth

	|robot|
	"given"
	robot := Robot new.
	robot north.
	"when"
	robot move: 30.
	"then"
	self assert: robot position equals: 0 @ 30! !

!RobotTest methodsFor: 'movements' stamp: 'NahuelGarbezza 12/22/2012 18:26'!
testMoveStraightToSouth

	|robot|
	"given"
	robot := Robot new.
	robot south.
	"when"
	robot move: 50.
	"then"
	self assert: robot position equals: 0 @ -50! !

!RobotTest methodsFor: 'movements' stamp: 'NahuelGarbezza 12/22/2012 18:26'!
testMoveStraightToWest

	|robot|
	"given"
	robot := Robot new.
	robot west.
	"when"
	robot move: 110.
	"then"
	self assert: robot position equals: -110 @ 0! !

!RobotTest methodsFor: 'movements - brush down' stamp: 'NahuelGarbezza 12/22/2012 19:02'!
testMovementsWithTheBrushDownModifyTheCurrentPath

	|robot|
	"given"
	robot := Robot new.
	"when"
	robot brushDown; east.
	robot move: 30; south; move: 50.
	"then"
	self assert: robot currentPath numberOfPoints equals: 3.
	self assert: robot currentPath points first equals: 0 @ 0.
	self assert: robot currentPath points second equals: 30 @ 0.
	self assert: robot currentPath points third equals: 30 @ -50.! !

!RobotTest methodsFor: 'positioning' stamp: 'NahuelGarbezza 12/22/2012 18:16'!
testPositionCanBePassedInConstructor

	|robot|
	"when"
	robot := Robot newWithPosition: 100@50.
	"then"
	self assert: robot position equals: 100@50! !

!RobotTest methodsFor: 'printing' stamp: 'NahuelGarbezza 12/22/2012 19:07'!
testRobotStringRepresentation

	|robot robotString|
	"given"
	robot := Robot new.
	"when"
	robotString := robot printString.
	"then"
	self assert: robotString equals: 'Robot at (0@0), direction 90'.
	"when"
	robot move: -40; west; move: 50.
	robotString := robot printString.
	"then"
	self assert: robotString equals: 'Robot at (-50@ -40), direction 180'.
	! !

!RobotTest methodsFor: 'state' stamp: 'NahuelGarbezza 12/22/2012 16:13'!
testStateIsSetToBrushDown

	|robot|
	"given"
	robot := Robot new.
	"when"
	robot brushDown.
	"then"
	self assert: robot isBrushDown.
	self deny: robot isBrushUp.! !

!RobotTest methodsFor: 'state' stamp: 'NahuelGarbezza 12/22/2012 16:14'!
testStateIsSetToBrushUp

	|robot|
	"given"
	robot := Robot new.
	"when"
	robot brushUp.
	"then"
	self assert: robot isBrushUp.
	self deny: robot isBrushDown.! !

!RobotTest methodsFor: 'state' stamp: 'NahuelGarbezza 12/22/2012 18:43'!
testToggleBrushUpAndDown

	|robot|
	"given"
	robot := Robot new.
	"when"
	robot brushDown.
	"then"
	self assert: robot isBrushDown.
	"when"
	robot brushUp.
	"then"
	self assert: robot isBrushUp.
	"when"
	robot brushDown.
	"then"
	self assert: robot isBrushDown.! !
